{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2018 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit libswiper;

interface

uses
  JS, Web, JSDelphiSystem;

type
  TJSSwiper = class (TJSObject)
  private
   fWidth: Integer;
   fHeight: Integer;
   fActiveIndex: Integer;
   fClickedIndex: Integer;
   fPreviousIndex: Integer;
   fClickedSlide: TJSHTMLElement;
   fAllowSlideNext: Boolean;
   fAllowSlidePrev: Boolean;
  public
    constructor New(domElement: TJSElement; options: TJSObject);
    procedure doDestroy(deleteInstance: Boolean; cleanStyles: Boolean);
    procedure appendSlide(slideHtml: String); overload;
    procedure appendSlide(slidesHtml: TJSArray); overload;
    procedure removeAllSlides;
    procedure update;
    procedure updateSize;
    procedure slideTo(anIndex: Integer; delaymsecs: Integer);
    procedure slideNext(delaymsecs: Integer);
    procedure slidePrev(delaymsecs: Integer);

    property Width: Integer read fWidth write fWidth;
    property Height: Integer read fHeight write fHeight;
    property ActiveIndex: Integer read fActiveIndex;
    property ClickedIndex: Integer read fClickedIndex;
    property PreviousIndex: Integer read fPreviousIndex;
    property clickedSlide: TJSHTMLElement read fClickedSlide;
    property AllowSlideNext: Boolean read fAllowSlideNext write fAllowSlideNext;
    property AllowSlidePrev: Boolean read fAllowSlidePrev write fAllowSlidePrev;

    procedure on(Const anEvent : String; aListener: JSValue);
  end;

  function CreateSwiper(
             aContainer: TJSElement;
             slidesPerView: Integer;
             spaceBetween: Integer;

             // pass nil for these parameters for Thumbnails Swiper
             buttonNext: TJSElement;
             buttonPrev: TJSElement;
             thumbNailsSwiper: TJSSwiper;

             transitionEffect: String;
             usePagination: Boolean = False;

             // pass True for these parameters for Thumbnails Swiper
             freeMode: Boolean = False;
             watchSlidesVisibility: Boolean = False;
             watchSlidesProgress: Boolean = False
           ): TJSSwiper;

implementation
{$HINTS OFF}
{$WARNINGS OFF}

function CreateSwiper(
             aContainer: TJSElement;
             slidesPerView: Integer;
             spaceBetween: Integer;
             buttonNext: TJSElement;
             buttonPrev: TJSElement;
             thumbNailsSwiper: TJSSwiper;
             transitionEffect: String;
             usePagination: Boolean = False;
             freeMode: Boolean = False;
             watchSlidesVisibility: Boolean = False;
             watchSlidesProgress: Boolean = False
           ): TJSSwiper;
begin
end;

constructor TJSSwiper.New(domElement: TJSElement; options: TJSObject);
begin
end;

procedure TJSSwiper.doDestroy(deleteInstance: Boolean; cleanStyles: Boolean);
begin
end;

procedure TJSSwiper.appendSlide(slideHtml: String);
begin
end;

procedure TJSSwiper.appendSlide(slidesHtml: TJSArray);
begin
end;

procedure TJSSwiper.removeAllSlides;
begin
end;

procedure TJSSwiper.update;
begin
end;

procedure TJSSwiper.updateSize;
begin
end;

procedure TJSSwiper.slideTo(anIndex: Integer; delaymsecs: Integer);
begin
end;

procedure TJSSwiper.slideNext(delaymsecs: Integer);
begin
end;

procedure TJSSwiper.slidePrev(delaymsecs: Integer);
begin
end;

procedure TJSSwiper.on(Const anEvent : String; aListener: JSValue);
begin
end;

end.
