{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Slider;


interface

uses
  Classes, WebLib.Graphics, SysUtils, Web, WebLib.Controls, js,
  WebLib.Menus, WEBLib.ExtCtrls, libswiper;

type
  TImageSlider = class;
  TSliderAppearance = class;

  TNavigationBullets = class(TPersistent)
  public
    constructor Create(AOwner: TSliderAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Color: TColor read FColor write SetColor default clLtGray;
    property ColorActive: TColor read FColorActive write SetColorActive default clBlue;
    property Size: Integer read FSize write SetSize default 12;
    property SpaceBetween: Integer read FSpaceBetween write SetSpaceBetween default 12;
    property SpaceEdge: Integer read FSpaceEdge write SetSpaceEdge default 8;
    property Opacity: double read FOpacity write SetOpacity;
  end;

  TNavigationThumbnails = class(TPersistent)
  public
    constructor Create(AOwner: TSliderAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property SizePercent: Integer read FSizePercent write SetSizePercent default 20;
    property NumDisplayed: Integer read FNumDisplayed write SetNumDisplayed default 6;
    property SizeAspectRatio: Boolean read FSizeAspectRatio write SetSizeAspectRatio default False;
    property SpaceBetween: Integer read FSpaceBetween write SetSpaceBetween default 8;
    property Opacity: double read FOpacity write SetOpacity;
    property ColorActiveBorder: TColor read FColorActiveBorder write SetColorActiveBorder default clBlack;
    property WidthActiveBorder: Integer read FWidthActiveBorder write SetWidthActiveBorder default 3;
    property OpacityActive: double read FOpacityActive write SetOpacityActive;
  end;

  TNavigationButtons = class(TPersistent)
  public
    constructor Create(AOwner: TSliderAppearance); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property Color: TColor read FColor write SetColor default clNone;
    property Visible: Boolean read FVisible write SetVisible default True;
  end;

  TNavigationStyle = (navsNone, navsThumbnails, navsBullets);
  TTransitionEffect = (tefSlide, tefFade, tefFlip);

  TSliderAppearance = class(TPersistent)
  public
    constructor Create(AOwner: TImageSlider); overload;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function GetOwner: TPersistent; override;
  published
    property NavigationStyle: TNavigationStyle read FNavigationStyle write SetNavigationStyle;
    property TransitionEffect: TTransitionEffect read FTransitionEffect write SetTransitionEffect;
    property Bullets: TNavigationBullets read FBullets write SetBullets;
    property Thumbnails: TNavigationThumbnails read FThumbnails write SetThumbnails;
    property Buttons: TNavigationButtons read FButtons write SetButtons;
  end;

  TImageSliderImageEvent = procedure(Sender: TObject; ImageIndex: integer) of object;
  TImageSliderThumbnailEvent = procedure(Sender: TObject; ImageIndex: integer) of object;

  TImageSlider = class(TCustomControl)
  protected
    procedure SetStyles;
    function CreateElement: TJSElement; override;
    procedure CreateInitialize; override;
    procedure SetImageURLs(const Value: TStringList);
    procedure update;
    procedure UpdateElementSize; override;
    procedure UpdateElementVisual; override;
    procedure AddSlides(aSwiper: TJSSwiper; isThumbnailsSwiper: Boolean);
    procedure CreateSwipers;
    procedure RecreateSwipers;
    procedure InitScript; override;
    procedure SetColor(AValue: TColor); override;
    function GetActiveImageIndex: Integer;
    procedure SetActiveImageIndex(Value: Integer);
    function GetLastClickedIndex: Integer;
    function GetPreviousActiveIndex: Integer;

    function HandleDoClick(Event: TJSMouseEvent): Boolean; override;
    procedure HandleDoImageClick(Index: integer); virtual;
    procedure HandleDoThumbnailClick(Index: integer); virtual;
    procedure HandleDoImageChange(Event: TJSEvent); virtual;
  public
    constructor Create(AOwner: TComponent); overload; override;
    destructor Destroy; override;
    procedure RefreshImages;
    procedure SlideTo(anIndex: Integer; delaymsecs: Integer = 0);
    procedure SlideNext(delaymsecs: Integer = 0);
    procedure SlidePrev(delaymsecs: Integer = 0);
    procedure SlideFirst(delaymsecs: Integer = 0);
    procedure SlideLast(delaymsecs: Integer = 0);

    property ImageSwiper: TJSSwiper read FImageSwiper;
    property ThumbnailsSwiper: TJSSwiper read FThumbnailsSwiper;
    property ActiveImageIndex: Integer read GetActiveImageIndex write SetActiveImageIndex;
    property PreviousActiveIndex: Integer read GetPreviousActiveIndex;
    property LastClickedIndex: Integer read GetLastClickedIndex;

  published
    property Align;
    property AlignWithMargins;
    property Anchors;
    property Color;
    property ImageURLs: TStringList read FImageURLs write SetImageURLs;
    property Appearance: TSliderAppearance read FAppearance write FAppearance;

    property OnImageChange: TImageSliderImageEvent read FOnImageChange write FOnImageChange;
    property OnImageClick: TImageSliderImageEvent read FOnImageClick write FOnImageClick;
    property OnThumbnailClick: TImageSliderThumbnailEvent read FOnThumbnailClick write FOnThumbnailClick;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
  end;

  TWebImageSlider = class(TImageSlider);

implementation
end.
